﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using Infragistics.Windows.DataPresenter;
using GLAP.Objects;
using System.Windows.Media;

namespace GLAP
{
    internal class CVPStyleSelector_Field : StyleSelector
    {
        private Style _editedStyle;
        private Style _regularStyle;

        internal CVPStyleSelector_Field(Style RegularStyle, Style EditedStyle)
        {
            this._editedStyle = EditedStyle;
            this._regularStyle = RegularStyle;
        }

        public override Style SelectStyle(object item, DependencyObject container)
        {
            CellValuePresenter cvp = container as CellValuePresenter;
            if (cvp.Record.DataItem != null)
            {                    
                if (cvp.Record.DataItem.GetType().Name.Equals("Forecast"))
                {
                    Forecast myForecast = cvp.Record.DataItem as Forecast;
                    Load myLoad = myForecast.Loads.FirstOrDefault(f => f.Name.Equals(cvp.Field.Name));
                    if (myLoad != null)
                    {
                        if (myLoad.OverrideColumn.Equals(myForecast.Name))
                        {
                            return _editedStyle;
                        }
                        else
                        {
                            return _regularStyle;
                        }
                    }
                    else
                    {
                        return _regularStyle;
                    }
                }
                else
                {
                    Node myNode = cvp.Record.DataItem as Node;
                    if (myNode.NumChildren() > 0)
                    {
                        foreach (Node child in myNode.Child)
                        {
                            foreach (Forecast newForecast in child.Forecasts)
                            {
                                Load myLoad = newForecast.Loads.FirstOrDefault(f => f.Name.Equals(cvp.Field.Name));
                                if (myLoad != null)
                                {
                                    if (myLoad.OverrideColumn.Equals(newForecast.Name))
                                    {
                                        return _editedStyle;
                                    }
                                }
                            }
                            //Load myLoad = child.Loads.FirstOrDefault(f => f.Name.Equals(cvp.Field.Name));
                            //if (f.OverrideColumn.Equals(myForecast.Name))
                            //    return _editedStyle;
                        }
                    }
                    else 
                    {
                        foreach (Forecast newForecast in myNode.Forecasts)
                        {
                            Load myLoad = newForecast.Loads.FirstOrDefault(f => f.Name.Equals(cvp.Field.Name));
                            if (myLoad != null)
                            {
                                if (myLoad.OverrideColumn.Equals(newForecast.Name))
                                {
                                    return _editedStyle;
                                }
                            }
                        }
                    }
                    //check if chlid(ren) have been edited or edit a node to hold a isOverride flag
                    return _regularStyle; 
                }
            }
            else
            {
                return _regularStyle; 
            }
        }
    }
}
