﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows.Data;
using System.Windows;
using Infragistics.Windows.DataPresenter;
using GLAP.Objects;

namespace GLAP
{
    public class FindSums2 : IValueConverter
    {
        #region IValueConverter Members

        public object Convert(object value, Type targetType, object parameter, System.Globalization.CultureInfo culture)
        {
            Node myNode = value as Node;
            return CalculateTotal(myNode, parameter);
        }

        public static double CalculateTotal(Node myNode, object val)
        {
            double total = 0.00;

            if (myNode != null)
            {
                if (myNode.NumChildren() > 0)
                {
                    foreach (Node child in myNode.Child)
                    {
                        total += CalculateTotal(child, val);
                    }
                }
                else
                {
                    foreach (Forecast f in myNode.Forecasts)
                    {
                        total += f.Loads[int.Parse(val.ToString())].Value;
                    }
                }
                return total;
            }
            else
            {
                return int.Parse(val.ToString());
            }
        }

        public object ConvertBack(object value, Type targetType, object parameter, System.Globalization.CultureInfo culture)
        {
            //  throw new NotImplementedException();
            return value;
        }

        #endregion
    }
}
